summaryrefslogtreecommitdiffstats
path: root/tests/rmdir
diff options
context:
space:
mode:
Diffstat (limited to 'tests/rmdir')
-rwxr-xr-xtests/rmdir/fail-perm.sh32
-rwxr-xr-xtests/rmdir/ignore.sh49
-rwxr-xr-xtests/rmdir/t-slash.sh29
3 files changed, 110 insertions, 0 deletions
diff --git a/tests/rmdir/fail-perm.sh b/tests/rmdir/fail-perm.sh
new file mode 100755
index 0000000..72f502d
--- /dev/null
+++ b/tests/rmdir/fail-perm.sh
@@ -0,0 +1,32 @@
+#!/bin/sh
+# For unwritable directory 'd', 'rmdir -p d d/e/f' would emit
+# diagnostics but would not fail. Fixed in 5.1.2.
+
+# Copyright (C) 2004-2020 Free Software Foundation, Inc.
+
+# This program is free software: you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation, either version 3 of the License, or
+# (at your option) any later version.
+
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+
+# You should have received a copy of the GNU General Public License
+# along with this program. If not, see <https://www.gnu.org/licenses/>.
+
+. "${srcdir=.}/tests/init.sh"; path_prepend_ ./src
+print_ver_ rmdir
+
+mkdir d d/e d/e/f || framework_failure_
+chmod a-w d || framework_failure_
+
+
+# This rmdir command outputs two diagnostics.
+# Before coreutils-5.1.2, it would mistakenly exit successfully.
+# As of coreutils-5.1.2, it fails, as required.
+returns_ 1 rmdir -p d d/e/f 2> /dev/null || fail=1
+
+Exit $fail
diff --git a/tests/rmdir/ignore.sh b/tests/rmdir/ignore.sh
new file mode 100755
index 0000000..65e92d0
--- /dev/null
+++ b/tests/rmdir/ignore.sh
@@ -0,0 +1,49 @@
+#!/bin/sh
+# make sure rmdir's --ignore-fail-on-non-empty option works
+
+# Copyright (C) 1999-2020 Free Software Foundation, Inc.
+
+# This program is free software: you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation, either version 3 of the License, or
+# (at your option) any later version.
+
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+
+# You should have received a copy of the GNU General Public License
+# along with this program. If not, see <https://www.gnu.org/licenses/>.
+
+. "${srcdir=.}/tests/init.sh"; path_prepend_ ./src
+print_ver_ rmdir
+
+cwd=$(pwd)
+mkdir -p "$cwd/a/b/c" "$cwd/a/x" || framework_failure_
+
+rmdir -p --ignore-fail-on-non-empty "$cwd/a/b/c" || fail=1
+# $cwd/a/x should remain
+test -d "$cwd/a/x" || fail=1
+# $cwd/a/b and $cwd/a/b/c should be gone
+test -d "$cwd/a/b" && fail=1
+test -d "$cwd/a/b/c" && fail=1
+
+# Ensure that with --ignore-fail-on-non-empty, we still fail, e.g., for EPERM.
+# Between 6.11 and 8.31, the following rmdir would mistakenly succeed.
+mkdir -p x/y || framework_failure_
+chmod a-w x || framework_failure_
+returns_ 1 rmdir --ignore-fail-on-non-empty x/y || fail=1
+test -d x/y || fail=1
+# Between 6.11 and 8.31, the following rmdir would mistakenly fail,
+# and also give a non descript error
+touch x/y/z || framework_failure_
+rmdir --ignore-fail-on-non-empty x/y || fail=1
+test -d x/y || fail=1
+# assume empty dir if unreadable entries (so failure to remove diagnosed)
+rm x/y/z || framework_failure_
+chmod a-r x/y || framework_failure_
+returns_ 1 rmdir --ignore-fail-on-non-empty x/y || fail=1
+test -d x/y || fail=1
+
+Exit $fail
diff --git a/tests/rmdir/t-slash.sh b/tests/rmdir/t-slash.sh
new file mode 100755
index 0000000..3739ae1
--- /dev/null
+++ b/tests/rmdir/t-slash.sh
@@ -0,0 +1,29 @@
+#!/bin/sh
+# make sure rmdir -p works on a directory specified with a trailing slash
+
+# Copyright (C) 2002-2020 Free Software Foundation, Inc.
+
+# This program is free software: you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation, either version 3 of the License, or
+# (at your option) any later version.
+
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+
+# You should have received a copy of the GNU General Public License
+# along with this program. If not, see <https://www.gnu.org/licenses/>.
+
+. "${srcdir=.}/tests/init.sh"; path_prepend_ ./src
+print_ver_ rmdir
+
+mkdir dir || framework_failure_
+
+
+# Prior to coreutils-4.5.2, this would fail with the following:
+# rmdir: 'dir': No such file or directory
+rmdir -p dir/ || fail=1
+
+Exit $fail